<?php
/**
 * @package WXSIM-Forecast
 * @author Rob Douglass
 * @version 1.0
 */
/*
Plugin Name: WXSIM Forecast
Plugin URI: http://www.jmrwebsolutions.co.uk
Description: This Plugin is just a port from Saratoga weather scripts for use in Wordpress
Author: Rob Douglass
Version: 1.0
Author URI: http://www.jmrwebsolutions.co.uk
*/

if (!class_exists("WXSIMForecast")) {
    class WXSIMForecast {
	    var $adminOptionsName = "WXSIMForecastAdminOptions";
        function WXSIMForecast() { //constructor
           
        }
		
		function  init() {
            $this->getAdminOptions();
        }

		
		//Returns an array of admin options
        function getAdminOptions() {
            $WXSIMForecastAdminOptions = array('station' => 'Unknown',
                'plaintextfile' => './plaintext.txt',
                'tempdegrees' => 'C',
				'language' => 'en',
				'maxwidth' => '100%',
				'maxicons' => '10',
				'minpop' => '40',
				'showbeaufort' => 'T',
				'showhumidex' => 'false',
				'showfrost' => 'false',
				'showheatidx' => 'false');
			
            $WXSIMOptions = get_option($this->adminOptionsName);
            if (!empty($WXSIMOptions)) {
                foreach ($WXSIMOptions as $key => $option)
				    if (!empty($WXSIMForecastAdminOptions[$key])) {
                        $WXSIMForecastAdminOptions[$key] = $option;
					}
            }            
            update_option($this->adminOptionsName, $WXSIMForecastAdminOptions);
            return $WXSIMForecastAdminOptions;
        }
//Prints out the admin page
        function printAdminPage() {
                    $devOptions = $this->getAdminOptions();
                                       
                    if (isset($_POST['update_WXSIMForecastSettings'])) {
                        if (isset($_POST['WXSIMstation'])) {
                            $devOptions['station'] = $_POST['WXSIMstation'];
                        }   
                        if (isset($_POST['WXSIMplaintextfile'])) {
                            $devOptions['plaintextfile'] = $_POST['WXSIMplaintextfile'];
                        }   
                        if (isset($_POST['WXSIMtempdegrees'])) {
                            $devOptions['tempdegrees'] = $_POST['WXSIMtempdegrees'];
                        } 
						if (isset($_POST['WXSIMlanguage'])) {
                            $devOptions['language'] = $_POST['WXSIMlanguage'];
                        }  
						if (isset($_POST['WXSIMmaxwidth'])) {
                            $devOptions['maxwidth'] = $_POST['WXSIMmaxwidth'];
                        }  						
						if (isset($_POST['WXSIMmaxicons'])) {
                            $devOptions['maxicons'] = $_POST['WXSIMmaxicons'];
                        }  	
						if (isset($_POST['WXSIMminpop'])) {
                            $devOptions['minpop'] = $_POST['WXSIMminpop'];
                        }  							
                        if (isset($_POST['WXSIMshowbeaufort'])) {
                            $devOptions['showbeaufort'] = $_POST['WXSIMshowbeaufort'];
                        }
						if (isset($_POST['WXSIMshowhumidex'])) {
                            $devOptions['showhumidex'] = $_POST['WXSIMshowhumidex'];
                        } 
						if (isset($_POST['WXSIMshowfrost'])) {
                            $devOptions['showfrost'] = $_POST['WXSIMshowfrost'];
                        } 
						if (isset($_POST['WXSIMshowheatidx'])) {
                            $devOptions['showheatidx'] = apply_filters('content_save_pre', $_POST['WXSIMshowheatidx']);
                        } 
				
                        update_option($this->adminOptionsName, $devOptions);
                       
                        ?>
                        <div class="updated"><p><strong><?php _e("Settings Updated.", "WXSIMForecast");?></strong></p></div>
                        <?php } ?>
                        <div class=wrap>
						<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
						<h2>WXSIM Forecast</h2>
						<h3>Weather Station</h3>
						<textarea name="WXSIMstation" style="width: 40%; height: 30px;"><?php _e(apply_filters('format_to_edit',$devOptions['station']), 'WXSIMForecast') ?></textarea>

						<h3>Plain Text File</h3>
						<textarea name="WXSIMplaintextfile" style="width: 40%; height: 30px;"><?php _e(apply_filters('format_to_edit',$devOptions['plaintextfile']), 'WXSIMForecast') ?></textarea>


						<h3>Temperature Degrees</h3>
						<p>Selecting either &deg;C or &deg;F depending on your preference</p>
						<p><label for="WXSIMtempdegrees_C"><input type="radio" id="WXSIMtempdegrees_C" name="WXSIMtempdegrees" value="C" 
						<?php if ($devOptions['tempdegrees'] == "C") { _e('checked="checked"', "WXSIMForecast"); }?> /> &deg;C</label>&nbsp;&nbsp;&nbsp;&nbsp;
						<label for="WXSIMtempdegrees_F"><input type="radio" id="WXSIMtempdegrees_F" name="WXSIMtempdegrees" value="F" 
						<?php if ($devOptions['tempdegrees'] == "F") { _e('checked="checked"', "WXSIMForecast"); }?>/> &deg;F</label></p>

						<h3>Language</h3>
						<p>Please put the language file in the plugin folder</p>
						<textarea name="WXSIMlanguage" style="width: 10%; height: 30px;"><?php _e(apply_filters('format_to_edit',$devOptions['language']), 'WXSIMForecast') ?></textarea>

						<h3>Max Width</h3>
						<p>Can be specified in percentage or pixel</p>
						<textarea name="WXSIMmaxwidth" style="width: 10%; height: 30px;"><?php _e(apply_filters('format_to_edit',$devOptions['maxwidth']), 'WXSIMForecast') ?></textarea>

                        <h3>Max Icons</h3>
						<p>Set to the maximum number of icons to display</p>
						<textarea name="WXSIMmaxicons" style="width: 10%; height: 30px;"><?php _e(apply_filters('format_to_edit',$devOptions['maxicons']), 'WXSIMForecast') ?></textarea>

						<h3>Minimum Probability of Precipitation(PoP)</h3>
						<p>PoP percentage must equal this value or above to display rain icon, otherwise the sky icon with PoP is displayed.</p>
						<textarea name="WXSIMminpop" style="width: 10%; height: 30px;"><?php _e(apply_filters('format_to_edit',$devOptions['minpop']), 'WXSIMForecast') ?></textarea>
						
						<h3>Display Beaufort</h3>
						<p>Set to V' for no Beaufort and set to 'T' for translated name</p>
						<p><label for="WXSIMshowbeaufort_V"><input type="radio" id="WXSIMshowbeaufort_V" name="WXSIMshowbeaufort" value="V" 
						<?php if ($devOptions['showbeaufort'] == "V") { _e('checked="checked"', "WXSIMForecast"); }?> /> V</label>&nbsp;&nbsp;&nbsp;&nbsp;
						<label for="WXSIMshowbeaufort_T"><input type="radio" id="WXSIMshowbeaufort_T" name="WXSIMshowbeaufort" value="T" 
						<?php if ($devOptions['showbeaufort'] == "T") { _e('checked="checked"', "WXSIMForecast"); }?>/> T</label></p>

						<h3>Show Humidity Index?</h3>
                        <p>Selecting "No" will disable the humidity index from being displayed.</p>
                        <p><label for="WXSIMshowhumidex_true"><input type="radio" id="WXSIMshowhumidex_true" name="WXSIMshowhumidex" value="true"
						<?php if ($devOptions['showhumidex'] == "true") { _e('checked="checked"', "WXSIMForecast"); }?> /> Yes</label>&nbsp;&nbsp;&nbsp;&nbsp;
						<label for="WXSIMshowhumidex_false"><input type="radio" id="WXSIMshowhumidex_false" name="WXSIMshowhumidex" value="false"
						<?php if ($devOptions['showhumidex'] == "false") { _e('checked="checked"', "WXSIMForecast"); }?>/> No</label></p>
						
						<h3>Show Frost?</h3>
                        <p>Selecting "No" will disable the Frost from being displayed.</p>
                        <p><label for="WXSIMshowfrost_yes"><input type="radio" id="WXSIMshowfrost_yes" name="WXSIMshowfrost" value="true" 
						<?php if ($devOptions['showfrost'] == "true") { _e('checked="checked"', "WXSIMForecast"); }?> /> Yes</label>&nbsp;&nbsp;&nbsp;&nbsp;
						<label for="WXSIMshowfrost_no"><input type="radio" id="WXSIMshowfrost_no" name="WXSIMshowfrost" value="false" 
						<?php if ($devOptions['showfrost'] == "false") { _e('checked="checked"', "WXSIMForecast"); }?>/> No</label></p>
						
						<h3>Show Heat Index?</h3>
                        <p>Selecting "No" will disable the heat index from being displayed.</p>
                        <p><label for="WXSIMshowheatidx_yes"><input type="radio" id="WXSIMshowheatidx" name="WXSIMshowheatidx" value="true" 
						<?php if ($devOptions['showheatidx'] == "true") { _e('checked="checked"', "WXSIMForecast"); }?> /> Yes</label>&nbsp;&nbsp;&nbsp;&nbsp;
						<label for="WXSIMshowheatidx_no"><input type="radio" id="WXSIMshowheatidx_no" name="WXSIMshowheatidx" value="false" 
						<?php if ($devOptions['showheatidx'] == "false") { _e('checked="checked"', "WXSIMForecast"); }?>/> No</label></p>
						
						<div class="submit">
							<input type="submit" name="update_WXSIMForecastSettings" value="<?php _e('Update Settings', 'WXSIMForecast') ?>" /></div>
							</form>
						</div>
						<?php
				}//End function printAdminPage()
		
			 
				
    }

} //End Class WXSIMForecast

   
      function addHeaderCode() {
           echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/wxsim-forecast/css/WXSIMforecast.css" />' . "\n";
         }
        add_action('wp_head', 'addHeaderCode');





	//Initialize the admin panel
if (!function_exists("WXSIMForecast_ap")) {
	function WXSIMForecast_ap() {
		global $WXSIM_pluginSeries;
		if (!isset($WXSIM_pluginSeries)) {
			return;
		}
		if (function_exists('add_options_page')) {
			add_options_page('WXSIM Forecast', 'WXSIM Forecast', 9, basename(__FILE__), array(&$WXSIM_pluginSeries, 'printAdminPage'));
		}
	}  
}	

function WXSIMforecast_func() {

// plaintext-parser.php script by Ken True - webmaster@saratoga-weather.org
//
// Version 0.90 - 24-Mar-2007 - Pre-release - testing and commments version
// Version 0.91 - 25-Mar-2007 - fixed day/night icon glitch for translated languages
// Version 0.92 - 27-Mar-2007 - added conditionals for selective printing, optional degrees, and
//                              capitalization for First letter of sentence in translation.
// Version 1.00 - 30-Mar-2007 - changed primary parsing to support IIS, and added minPoP to
//                              display sky condition (with pop) instead of rain icon.
// Version 1.01 - 02-Apr-2007 - support for UTF-8 display, translation of City names, Date format option
// Version 1.02 - 16-May-2007 - minor change to allow operation with plaintext-rss.php
// Version 1.03 - 03-Jun-2007 - Added Wind dir/speed/units forecast and changed table generation method
// Version 1.04 - 27-Jul-2007 - Added Beaufort options for wind speed display
// Version 1.05 - 04-Aug-2007 - Modified Beaufort to use 'mps' or 'm/s' for meters-per-second
// Version 1.06 - 06-Sep-2007 - Added support for charset in lang files + Greek translation
// Version 1.07 - 07-Nov-2007 - Added support for GMT/Zulu time from WXSIM plaintext.txt
// Version 1.08 - 28-Dec-2007 - Added Snow Accumulation stats to PoP line when available
// Version 1.09 - 02-Jan-2008 - Added settings for integration to Carterlake/AJAX/PHP site design and
//                              'not available' message capability
// Version 1.10 - 12-May-2008 - fixed &rArr; to &rarr; for right-arrow in wind display
// Version 1.11 - 29-Jul-2008 - added $maxIcons to control number of icons to display
// Version 1.12 - 09-Aug-2008 - added $showIconsMax parameter (optional) to override $maxIcons
// Version 1.13 - 10-Sep-2008 - added support for multi-char Wind direction (for -pl language)
// Version 1.14 - 11-Jan-2009 - fixed Beaufort and added Snow/Freezing level support 
// Version 1.15 - 14-Jan-2009 - added $tempDegrees symbols for wind chill and heat index text
// Version 1.16 - 05-Feb-2009 - fixed plaintext occasional parsing issue
// Version 1.17 - 18-Jun-2009 - added fix for missing leading space in plaintext.txt lines
// Version 1.18 - 09-Jul-2010 - added support for Humidex and frost forecast optional displays
// Version 1.19 - 12-Aug-2010 - added support for Heat-index and 'hot' icon for Heat-index/humidex above specified values
//
$Version = "plaintext-parser.php Version 1.19 - 12-Aug-2010";
//
// error_reporting(E_ALL);  // uncomment to turn on full error reporting
//
// script available at http://saratoga-weather.org/scripts.php
//  
// you may copy/modify/use this script as you see fit,
// no warranty is expressed or implied.
//
// This script parses the plaintext.txt forecast output from WXSIM 
//  (http://www.wxsim.com/) to create a HTML page that resembles
//  the NOAA NWS point-printable forecast page in the carterlake advforecast.php style.
//
// output: creates XHTML 1.0-Strict HTML page (or inclusion)
//
// This script requires the NOAA icons and the icons need to be placed in the path 
// where the original NOAA icons are located: \forecast\images\
// (so make a folder in your web HTML root called "forecast", then make a folder in it 
// called "images", and place the icons in this folder)
// The icon set is available at http://saratoga-weather.org/carterlake-icons.zip 
// If you have the icon set from:
//   http://members.cox.net/carterlakeweather/forecasticons.zip (380K)
// then please download http://saratoga-weather.org/carterlake-icons-addon.zip and
// upload to your /forecast/images directory.  It contains images to support the
// "show sky conditions when chance rain and PoP < $minPoP" logic.
//
//
// Options on URL:
//   lang=en          (default) - use English language
//   lang=ZZ          - use 'ZZ' language translation file for conversion from English
//                    note: there must be a plaintext-parser-lang-LL.txt file with the
//                    conversion rules.   A sample Dutch file is included (lang=nl).
//
//   inc=Y            - omit <HTML><HEAD></HEAD><BODY> and </BODY></HTML> from output
//   heading=n        - (default)='y' suppress printing of heading (forecast city/by/date)
//   icons=n          - (default)='y' suppress printing of the icons+conditions+temp+wind+UV
//   text=n           - (default)='y' suppress printing of the periods/forecast text
//
//
//  You can also invoke these options directly in the PHP like this
//
//    $doInclude = true;
//    include("plaintext-parser.php");  for just the text
//  or ------------
//    $doPrint = false;
//    include("plaintext-parser.php");  for setting up the $WXSIM... variables without printing
//
//  or ------------
//    $doInclude = true;
//    $doPrintHeading = true;
//    $doPrintIcons = true;
//    $doPrintText = false
//    include("plaintext-parser.php");  include mode, print only heading and icon set
//
// Variables returned (useful for printing an icon or forecast or two...)
//
// $WXSIMcity 		- Name of city from WXSIM Forecast header
// $WXSIMstation    - (in settings below) Name of forecaster or weather station
// $WXSIMupdated 	- Time of forecast from WXSIM Forecast header
//
// The following variables exist for $i=0 to $i= number of forecast periods minus 1
//  a loop of for ($i=0;$i<count($WXSIMday);$i++) { ... } will loop over the available 
//  values.
//
// $WXSIMday[$i]	- period of forecast (translated)
// $WXSIMtext[$i]	- text of forecast (translated)
// $WXSIMuv[$i]		- UV index value (number)
//      note: you can use 'set_UV_string($WXSIMuv[$i])' to get a UV N and meaning text
// $WXSIMtemp[$i]	- Temperature with translated text and formatting
// $WXSIMpop[$i]	- Number - Probabability of Precipitation ('',10,20, ... ,100)
// $WXSIMprecip[$i] - amount of precipitation (native units from plaintext forecast)
// $WXSIMicon[$i]   - base name of icon graphic to use
// $WXSIMcond[$i]   - Short legend for forecast icon (translated)
// $WXSIMicons[$i]  - Full icon with translated Period, <img> and Short legend.
//  the following were added in V1.03:
// $WXSIMwinddir[$i]- Wind direction ( may be something like 'SSE' or 'NW->N' ) (translated)
// $WXSIMwind[$i]   - Wind speed (may be something like '10' or '7->4' or '10-16->6' )
// $WXSIMgust[$i]   - Wind gust
// $WXSIMwindunits[$i] - Wind speed units (mph, kph, mps, kts) (translated)
// $WXSIMBeaufort[$i]  - Beaufort scale for max wind speed 'n Bft' or 'Light air' (translated)
// $WXSIMhumidex[$i] - humidex number (or '' if not present in forecast)
// $WXSIMfrost[$i]  - frost forecast (or ''' if not present in forecast)
// $WXSIMheatidx[$i]  - heat-index forecast (or ''' if not present in forecast)
// Note:
//
// Settings ---------------------------------------------------------------
global $LanguageLookup, $doTranslate;
$WXSIMOptions = get_option(WXSIMForecastAdminOptions);  //Load array from wordpress options table

$iconDir ='./wp-content/plugins/wxsim-forecast/images/';           // directory for carterlake icons
$WXSIMstation = $WXSIMOptions['station'];                          // name of your weather station
$plaintextFile = $WXSIMOptions['plaintextfile'];       			   // location of the WXSIM plaintext.txt
$lang = $WXSIMOptions['language'];                                 // default language is 'en' = English
$tempDegrees = '&deg;' . $WXSIMOptions['tempdegrees'];             // set to '' to omit degree sign
//                                                                 //   or set to '&deg;', '&deg;F' or '&deg;C'
$maxIcons = $WXSIMOptions['maxicons'];                             // set to maximum number of icons to display
$maxWidth = $WXSIMOptions['maxwidth'];                             // max width of tables (could be '100%')
$minPoP = $WXSIMOptions['minpop'];                                 // PoP must be this or above to display
//                                                                 // rain icon, otherwise sky icon w/PoP displayed.
$showBeaufort = $WXSIMOptions['showbeaufort'];					   // set to false to not display Beaufort at all
//										                           // ='V' for 'n Bft', ='T' for translated name
$showHumidex = false;                                              // =true to display Humidex (Hdx), =false to suppress display
$showFrost = false;                                                // =true to display frost, =false to suppress display
$showHeatIDX = false;                                              // =true to display Heat-Index (HI), =false to suppress display
if ($WXSIMOptions['showhumidex'] == "true") {$showHumidex = true;}
if ($WXSIMOptions['showfrost'] == "true") {$showFrost = true;}
if ($WXSIMOptions['showheatidx'] == "true") {$showHeatIDX = true;}
                    
$showHotIconF = 100;                                               // show Hot icon if Heat-Index >= value
$showHotIconC = 37.7;                                              // show Hot icon if Humidex >= value
// ---- end of settings ---------------------------------------------------
// ---- end of settings ---------------------------------------------------
//
// overrides from Settings.php if available
global $SITE;
if (isset($SITE['fcsticonsdir'])) 	{$iconDir = $SITE['fcsticonsdir'];}
if (isset($SITE['defaultlang'])) 	{$lang = $SITE['defaultlang'];}
// end of overrides from Settings.php
//
// -------------------begin code ------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   //--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   
   readfile($filenameReal);
   exit;
}
$Status = "<!-- $Version -->\n";
$doTranslate = true;                      
if (isset($_REQUEST['lang']) ) {
  $lang=strtolower($_REQUEST['lang']);
  if ($lang == 'en') { $doTranslate = false; };
}
global $doDebug;
$doDebug = false;
if (isset($_REQUEST['debug']) ) {
  $doDebug = substr(strtolower($_REQUEST['debug']),0,1) == 'y';
}

$printHeading = true;
$printIcons = true;
$printText = true;

if (isset($doPrintHeading)) {
  $printHeading = $doPrintHeading;
}
if (isset($_REQUEST['heading']) ) {
  $printHeading = substr(strtolower($_REQUEST['heading']),0,1) == 'y';
}

if (isset($doPrintIcons)) {
  $printIcons = $doPrintIcons;
}
if (isset($_REQUEST['icons']) ) {
  $printIcons = substr(strtolower($_REQUEST['icons']),0,1) == 'y';
}
if (isset($doPrintText)) {
  $printText = $doPrintText;
}
if (isset($_REQUEST['text']) ) {
  $printText = substr(strtolower($_REQUEST['text']),0,1) == 'y';
}

if (isset($showIconsMax)) {
  $maxIcons = $showIconsMax;
}
if (isset($_REQUEST['maxicons']) ) {
  $maxIcons = $_REQUEST['maxicons'];
  $maxIcons = preg_replace('|[^\d]+|is','',$maxIcons);
}

$useCharSet = 'iso-8859-1';
$UTFLang = ',gr,ru,cn,jp,';  // languages needing UTF-8 character set for display
$timeFormat = 'd-M-Y h:i a'; // default to USA format
// load the config file
$config = file("./wp-content/plugins/wxsim-forecast/plaintext-parser-data.txt");  // 
// load and merge the language file (if it exists)
if ($doTranslate and $lang <> 'en' and file_exists("./wp-content/plugins/wxsim-forecast/plaintext-parser-lang-$lang.txt") ) {
  $lfile = file("./wp-content/plugins/wxsim-forecast/plaintext-parser-lang-$lang.txt");
  foreach ($lfile as $val) {
    array_push($config,$val);
  }
  $Status .= "<!-- translation file for '$lang' loaded -->\n";
  if (strpos($UTFLang,$lang) > 0) {$useCharSet = 'UTF-8'; $Status .= "<!-- using UTF-8 -->\n";}
} else {
  $doTranslate = false;
  if($lang <> 'en') {
    $Status .= "<!-- translation file for '$lang' not found -->\n";
    $lang = 'en';
  }
}

// Initialize -- read in control file and place in $Conditions and $Precip
//  for later use

$LanguageLookup = array();

$WindLookup = array( // initialized by wind-direction abbreviations for icons
// NOTE: don't change these .. use LANGLOOKUP entries in the plaintext-parser-LL.txt
// translation control file instead.
'north' => 'N',
'north-northeast' => 'NNE',
'northeast' => 'NE',
'east-northeast' => 'ENE',
'east' => 'E',
'east-southeast' => 'ESE',
'southeast' => 'SE',
'south-southeast' => 'SSE',
'south' => 'S',
'south-southwest' => 'SSW',
'southwest' => 'SW',
'west-southwest' => 'WSW',
'west' => 'W',
'west-northwest' => 'WNW',
'northwest' => 'NW',
'north-northwest' => 'NNW'
);

$BeaufortText = array(
// NOTE: don't change these .. use LANGLOOKUP entries in the plaintext-parser-LL.txt
// translation file instead.
'Calm', 'Light air', 'Light breeze','Gentle breeze', 'Moderate breeze', 'Fresh breeze', 
'Strong breeze', 'Near gale', 'Gale', 'Strong gale', 'Storm', 'Violent storm', 
'Hurricane' 
);
// wind speed < values below correspond to force 0 .. 11 . >= last value = force 12
$BeaufortKTS = array(
1,4,7,11,17,22,28,34,41,48,56,64,64
);
$BeaufortMPH = array(
1,4,8,13,19,25,32,39,47,55,64,73,73
);
$BeaufortKPH = array(
1,6,12,20,30,40,51,63,76,88,103,118,118
);
$BeaufortMS  = array(
0.2,1.6,3.4,5.5,8.0,10.8,13.9,17.2,20.8,24.5,28.5,32.7,32.7
);


reset($config);
// $Status .= "<!-- config: \n" . print_r($config,true) . " -->\n";
foreach ($config as $key => $rec) { // load the parser condition strings
  $recin = trim($rec);
  if ($recin and substr($recin,0,1) <> '#') { // got a non comment record
    list($type,$keyword,$dayicon,$nighticon,$condition) = explode('|',$recin . '|||||');
	
	if (isset($type) and strtolower($type) == 'cond' and isset($condition)) {
	  $Conditions["$keyword"] = "$dayicon\t$nighticon\t$condition";
	}
	if (isset($type) and strtolower($type) == 'precip' and isset($nighticon)) {
	  $Precip["$keyword"] = "$dayicon\t$nighticon";
	}
	if (isset($type) and strtolower($type) == 'snow' and isset($nighticon)) {
	  $Snow["$keyword"] = "$dayicon\t$nighticon";
	}
	if (isset($type) and strtolower($type) == 'lang' and isset($dayicon)) {
	  $Language["$keyword"] = "$dayicon";
    } 
	if (isset($type) and strtolower($type) == 'langlookup' and isset($dayicon)) {
	  $LanguageLookup["$keyword"] = "$dayicon";
    } 
	if (isset($type) and strtolower($type) == 'dateformat' and isset($keyword)) {
	  $timeFormat = trim($keyword);
    } 
	if (isset($type) and strtolower($type) == 'charset' and isset($keyword)) {
	  $useCharSet = trim($keyword);
	  $Status .= "<!-- using charset '$useCharSet' -->\n";
    } 
	if (isset($type) and strtolower($type) == 'notavail' and isset($keyword)) {
	  $notAvail = trim($keyword);
    } 
  } // end if not comment or blank
} // end loading of $Conditions and $Precip

if (count($LanguageLookup) < 1) {$doTranslate = false; }

$testFiles = array(  // local testing for Ken .. these files aren't part of the distribution
 'a' => 'plaintext-bin.txt',
 'b' => 'plaintext-test1.txt',
 'fr' => 'plaintext-cy.txt',
 'nl' => 'plaintext-du.txt',
 'it' => 'plaintext-it.txt',
 'se' => 'plaintext-se.txt',
 'nz' => 'plaintext-nz.txt',
 'snow' => 'plaintext-snow.txt',
 'rest' => 'plaintext-rest.txt',
 'oregon' => 'plaintext-oregon.txt',
 'fograin' => 'plaintext-fograin.txt',
 'snow2' => 'plaintext-snow2.txt',
 'snow3' => 'plaintext-snow3.txt',
 'snow4' => 'plaintext-snow4.txt',
 'snow5' => 'plaintext-snow5.txt',
 'snow6' => 'plaintext-snow6.txt',
 'snow7' => 'plaintext-snow7.txt',
 'snow8' => 'plaintext-snow8.txt',
 'snow9' => 'plaintext-snow9.txt',
 'snow10' => 'plaintext-snow10.txt',
 'gr' => 'plaintext-gr.txt',
 'zulu' => 'plaintext-zulu.txt',
 'beaufort' => 'plaintext-beaufort.txt',
 'snowlevel' => 'plaintext-snowlevel.txt',
 'thunder' => 'plaintext-thunder.txt',
 'thunder2' => 'plaintext-thunder2.txt',
 'broadstairs' => 'plaintext-broadstairs.txt',
 'hdx' => 'plaintext-hdx.txt',
 'frost' => 'plaintext-frost.txt',
 'hot' => 'plaintext-hot.txt',
);
 
if (isset($_REQUEST['test']) ) { // for testing only
  $t = strtolower($_REQUEST['test']);
  if (isset($testFiles[$t]) ) {
    $Status .= "<!-- using $testFiles[$t] for plaintext.txt -->\n";
	$plaintextFile = $testFiles[$t]; 
  }
}

if (isset($_REQUEST['minpop'])) { // for testing only
  $minPoP = $_REQUEST['minpop'];
}

// Read in the plaintext.txt forecast file for processing
if (! file_exists($plaintextFile) ) {
   $msg = "The WXSIM forecast is not currently available.";
   if (isset($notAvail)) {
     $msg = $notAvail;
   }
   print "<p>$msg</p>\n";
   return;
}
$pt = file($plaintextFile);
// fix missing space at start of line if need be
foreach ($pt as $i => $line) {
	if(substr($line,0,1) != ' ') {$pt[$i] = ' ' . $line;}
}
$plaintext = implode('',$pt);   // get the plaintext file.
// preprocess.. mark divisions in the forecast days for later parsing
$plaintext = preg_replace('![\n][\r|\n]+!s',"\n \n",$plaintext);
$plaintext = preg_replace('![\r|\n]+ [\r|\n]+!s',"\t\t",$plaintext); 
$plaintext .= "\t\t";  // make sure a delimiter is at the end too.
$plaintext = preg_replace('|_|is','',$plaintext); // remove dashed line in front

// Find city and update date
if (preg_match('|WXSIM text forecast for (.*), initialized at\s+(.*)|i',$plaintext,$matches)) {
  $WXSIMcity = get_lang(trim($matches[1]));
  $wdate = trim($matches[2]);
  $Status .= "<!-- wdate '$wdate' -->\n";
  // there are LOTS of formats of the date stamp in plaintext.txt
  // 012345678901234567890
  // 20:00   Feb 21, 2007
  // 15:00   02 Apr, 2007
  // 8:00 PM Mar 24, 2007
  // 12:00 AM 24 Mar, 2007
  // 17:00Z  05 Nov, 2007
  $wdateParts =  preg_split("/[\s,]+/", $wdate);
//  $Status .= "<!-- wdate split\n" . print_r($wdateParts,true) . " -->\n";
  $i=0;
  if (preg_match('!AM|PM!i',$wdateParts[1]) ) { // got US style date.
    list($wHrs,$wMins) = split(':',$wdateParts[0]);
	if (strtolower($wdateParts[1]) == 'pm' and $wHrs <> 12 ) {$wHrs += 12; }
	if (strtolower($wdateParts[1]) == 'am' and $wHrs == 12 ) {$wHrs = '00'; }
    $wTime = "$wHrs:$wMins";
	$i=1;
  } else {
    $wTime = $wdateParts[0];
  }
  if (preg_match('!\d+!',$wdateParts[$i+1]) ) { // got day in 1, month in 2 (+offset)
    $wDay = $wdateParts[$i+1];
	$wMon = $wdateParts[$i+2];
  } else {
    $wDay = $wdateParts[$i+2];
	$wMon = $wdateParts[$i+1];
  }
  $wYear = $wdateParts[$i+3];
  

//  $wdate = preg_replace('|(\S+)\s+(\S+)\s+(\S+),\s+(\S+)|s',"$2-$3-$4 $1:00 ".date('O',time()),$wdate);
  if(preg_match('|Z|i',$wTime) ) {
    // Zulu(GMT) time format
	$wTime = preg_replace('|Z|i','',$wTime);
    $wdate = "$wDay-$wMon-$wYear $wTime UTC";
    $Status .= "<!-- updated '$wdate'-->\n";
    $d = strtotime($wdate);
    $WXSIMupdated = get_lang(date('l',$d)) . ', ' . gmdate($timeFormat,$d) . ' UTC';
  } else {
    $wdate = "$wDay-$wMon-$wYear $wTime " . date('O',time());
    $Status .= "<!-- updated '$wdate'-->\n";
    $d = strtotime($wdate);
    $WXSIMupdated = get_lang(date('l',$d)) . ', ' . date($timeFormat,$d);
  }
}

// split up the forecast days and texts
// good preg_match_all('![\r|\n]+\s+(.*):\s(.*)[\r|\n]+ [\r|\n]+!Us',$plaintext,$matches);
preg_match_all('!\t\s(.*):\s(.*)\t!Us',$plaintext,$matches); // split up the forecast

// Main loop over each forecast text paragraph.
for ($i=0;$i<count($matches[1]);$i++) { // loop over results by forecast period and peel out values

 $WXSIMday[$i] = trim($matches[1][$i]);
 $WXSIMtext[$i] =  preg_replace('![\r|\n]+!is','',trim($matches[2][$i])); // remove CR and LF chars.
 // initialize this day's variables
 $WXSIMuv[$i] = '';
 $WXSIMtemp[$i] = '';
 $WXSIMpop[$i] = '';
 $WXSIMprecip[$i] = '';
 $WXSIMicon[$i] = '';
 $WXSIMcond[$i] = '';
 $WXSIMtempdirect[$i] = '';
 $WXSIMwinddir[$i] = '';
 $WXSIMwinddiricon[$i] = '';
 $WXSIMwind[$i] = '';
 $WXSIMgust[$i] = '';
 $WXSIMwindunits[$i] = '';
 $WXSIMhumidex[$i] = '';
 $WXSIMfrost[$i] = '';
 $WXSIMheatidx[$i] = '';
 
 // make the period 'pretty' with HTML breaks.
 $WXSIMtitles[$i] = preg_replace('! (\S+)$!',"<br />\\1",get_lang($WXSIMday[$i]));
 if (! preg_match('!<br />!',$WXSIMtitles[$i])) {
   $WXSIMtitles[$i] .= '<br />';  // add line break to 'short' day titles
 }
 
 // extract UV index value
 if (preg_match('|UV index up to (\d+)\.|i',$WXSIMtext[$i],$mtemp) ) {
   $WXSIMuv[$i] = $mtemp[1];
 }
 
 // extract Heat Index value
 if (preg_match('|Heat index up to (\d+)\.|i',$WXSIMtext[$i],$mtemp) ) {
   $WXSIMheatidx[$i] = $mtemp[1];
 }

// extract Humidex value
 if (preg_match('|Humidex up to (\d+)\.|i',$WXSIMtext[$i],$mtemp) ) {
   $WXSIMhumidex[$i] = $mtemp[1];
 }

 // extract Wind direction, values
 $testwind = str_replace('Wind chill','Wind-chill',$WXSIMtext[$i]);
 if (preg_match('|Wind (.*)\.|Ui',$testwind,$mtemp) ) {
//   $Status .= "<!-- mtemp[1]='" . $mtemp[1] . "' -->\n";
   $wtemp = preg_replace(
        '! around| near| in the| morning| evening| afternoon| midnight| tonight| to| after!Uis',
        '',$mtemp[1]);
//   $Status .= "<!-- stripped='" . $wtemp . "' -->\n";
   $wtemp = explode(', ',$wtemp);
//   $Status .= "<!-- wind\n" . print_r($wtemp, true) . " -->\n";
//    [0] => northwest around 5 mph
// or
//    [0] => northwest near calm
//    [1] => gusting to 12 mph
//    [2] => in the morning
//    [3] => becoming 12 mph in the afternoon
// or
//    [3] => becoming west-northwest around 12 mph in the afternoon
// or
//    [3] => becoming north-northwest in the afternoon

  $wparts = explode(' ',$wtemp[0]); // break it by spaces.
  $maxWind = 0;
  for ($k =0;$k<count($wtemp);$k++) {
    $wparts = explode(' ',$wtemp[$k]);
	
	if(isset($WindLookup[$wparts[0]]) ) { // got <dir> [speed] [units] format
	  $WXSIMwinddir[$i] = $WindLookup[$wparts[0]];  // get abbreviation for direction
      $WXSIMwinddiricon[$i] = $WXSIMwinddir[$i];    // base name for wind icon
      $WXSIMwind[$i] = $wparts[1];  // get speed
	  if ($wparts[1] > $maxWind and $wparts[1] <> 'calm') { $maxWind = $wparts[1]; }
      if ( isset($wparts[2])) {
       $WXSIMwindunits[$i] = $wparts[2]; // get wind units of measure
      }
    }
	
	if ($wparts[0] == 'gusting') {
	  $WXSIMwind[$i] .= '-' . $wparts[1];
	  if ($wparts[1] > $maxWind) { $maxWind = $wparts[1]; }
	  $WXSIMgust[$i] = $wparts[1];
	}
	if ($wparts[0] == 'becoming') { // got 'becoming [dir] [speed] [units]
	  if (isset($WindLookup[$wparts[1]]) ) {
	    $WXSIMwinddir[$i] .= '&rarr;' . $WindLookup[$wparts[1]];
	  }
	  if (preg_match('!(\d+|calm)!',$wtemp[$k],$match)) {
	    $WXSIMwind[$i] .= '&rarr;' . $match[1];
  	    if ($match[1] > $maxWind and $match[1] <> 'calm') { $maxWind = $match[1]; }
	  }
	  if (! $WXSIMwindunits[$i] and isset($wparts[2]) ) {
        $WXSIMwindunits[$i] = $wparts[2]; // get wind units of measure
	  }
	}
  
  }
   $WXSIMBeaufort[$i] = displayBeaufort(getBeaufort($maxWind,$WXSIMwindunits[$i])) ;
//   $Status .= "<!-- dir='" . $WXSIMwinddir[$i] . "' wind='" . $WXSIMwind[$i] . 
     "' gust='" . $WXSIMgust[$i] . "' units='" . $WXSIMwindunits[$i] . 
	 "' maxWind = '$maxWind' Beaufort='" . $WXSIMBeaufort[$i] . "'-->\n";
 }
 
 // extract temperature High/Low values
 if (preg_match('!(high|low) ([-|\d]+)[\.|,]!i',$WXSIMtext[$i],$mtemp)) {
   $WXSIMtemp[$i] = get_lang($mtemp[1] .':') . ' ' . $mtemp[2] . $tempDegrees;
   if ($tempDegrees) {  // fix up degrees in the text
      $WXSIMtext[$i] = preg_replace(
	  '|' . $mtemp[1] . ' ' . $mtemp[2] .'|',
	  $mtemp[1] . ' ' . $mtemp[2] . $tempDegrees,
	  $WXSIMtext[$i]);
	  $WXSIMtext[$i] = preg_replace('/Wind chill down to ([-|\d]+)/i',"Wind chill down to $1$tempDegrees",$WXSIMtext[$i]);
	  $WXSIMtext[$i] = preg_replace('/Heat index up to ([-|\d]+)/i',"Heat index up to $1$tempDegrees",$WXSIMtext[$i]);
//     $Status .= "<!-- WXSIMtext[$i]='".$WXSIMtext[$i]."' -->\n";
	  
   }
   if(substr($mtemp[1],0,1) == 'H') {
     $WXSIMtemp[$i] = '<span style="color: red">' . $WXSIMtemp[$i] . '</span>';
   } else {
     $WXSIMtemp[$i] = '<span style="color: blue">' . $WXSIMtemp[$i] . '</span>';
   }
 }  
 
 if (preg_match('!temperatures (rising|falling)!i',$WXSIMtext[$i],$mtemp)) {
   $WXSIMtempdirect[$i] = $mtemp[1];
 }
 
 // extract PoP
 if (preg_match('!Chance of precipitation (.*) percent!i',$WXSIMtext[$i],$mtemp)) {
//   print "<pre>" . print_r($mtemp,true) . "</pre>\n";
   $WXSIMpop[$i] = $mtemp[1];
   $WXSIMpop[$i] = preg_replace('|less than |i','<',$WXSIMpop[$i]);
   if ($WXSIMpop[$i] == '<20') {$WXSIMpop[$i] = '10';}
   if ($WXSIMpop[$i] == 'near 100') { $WXSIMpop[$i] = '100'; }
 }
 
 // extract frost
 if (preg_match('!with\s+(.*)\s+frost.!is',$WXSIMtext[$i],$mtemp)) {
//   print "<pre>" . print_r($mtemp,true) . "</pre>\n";
   $WXSIMfrost[$i] = 'Frost '.$mtemp[1];
  if ($doTranslate) {
    // perform optional translation if $Language has entries
    reset ($Language); // process in order of the file
    $text = $WXSIMfrost[$i];
    foreach ($Language as $key => $replacement) {
      $text = str_replace($key,$replacement,$text);
    }
	$WXSIMfrost[$i] = $text;
  }
 }

 // now look for harshest conditions first.. (in order in -data file
 if ($doDebug) {
   $Status .= "<!-- WXSIMtext[$i]='" . $WXSIMtext[$i] . "' -->\n";
 }
 reset($Conditions);  // Do search in load order
 foreach ($Conditions as $cond => $condrec) { // look for matching condition
   
   if(preg_match("!$cond!i",$WXSIMtext[$i],$mtemp)) {
     list($dayicon,$nighticon,$condition) = explode("\t",$condrec);
	 if (preg_match('!chance!i',$condition) and $WXSIMpop[$i] < $minPoP) {
	   continue; // skip this one
	 }
	 if (preg_match("|$cond level|i",$WXSIMtext[$i]) ) {
	   continue; // skip 'snow level' and 'freezing level' entries
	 }
	 $WXSIMcond[$i] = get_lang($condition);
	 if (preg_match('|night|i',$WXSIMday[$i])) {
	   $WXSIMicon[$i] = $nighticon;
	 } else {
	   $WXSIMicon[$i] = $dayicon;
	 }
	 break;
   }
 } // end of conditions search
 
 // look for precipitation amounts
 reset($Precip);  // Do search in load order
 foreach ($Precip as $pamt => $prec) { // look for matching precipitation amounts
   
   if(preg_match("!$pamt!is",$WXSIMtext[$i],$mtemp)) {
     list($amount,$units) = explode("\t",$prec);
	 $WXSIMprecip[$i] = $amount . ' ' . $units;
	 break;
    }
 } // end of precipitation amount search

 // look for Snow Accumulation
 reset($Snow);  // Do search in load order
 foreach ($Snow as $pamt => $prec) { // look for matching precipitation amounts
   
   if(preg_match("!$pamt!is",$WXSIMtext[$i],$mtemp)) {
     list($amount,$units) = explode("\t",$prec);
	 $WXSIMprecip[$i] .= "<br/><span style=\"color: blue\"><b>" . $amount . ' ' . $units . "</b></span>\n";
	 break;
    }
 } // end of Snow Accumulation amount search
 
 
//  now fix up the full icon name and PoP if available
  $curicon = $WXSIMicon[$i]  . '.jpg';
  if ($WXSIMpop[$i] > 0) {
	$testicon = preg_replace("|\.jpg|","$WXSIMpop[$i].jpg",$curicon);
//	print "<pre>testicon='$testicon'</pre>\n";
	if (file_exists($iconDir . $testicon)) {
      $WXSIMicon[$i] = $testicon;
	} else {
	  $WXSIMicon[$i] = $curicon;
	}
  } else {
    $WXSIMicon[$i] = $curicon;
  }

  if ($WXSIMtempdirect[$i] <> '') {
     $tempdirect = 'up.gif';
	 if (substr($WXSIMtempdirect[$i],0,1) == 'f') { $tempdirect='down.gif'; }
	 $WXSIMtemp[$i] .= "<img src=\"$iconDir$tempdirect\" height=\"10\" width=\"10\" alt=\" \" />";
  
  
  }
  
  if ($doTranslate) {
    // perform optional translation if $Language has entries
    reset ($Language); // process in order of the file
    $text = $WXSIMtext[$i];
    foreach ($Language as $key => $replacement) {
      $text = str_replace($key,$replacement,$text);
    }
	// put back translated text, fixing capitalization for sentence starts (except the first one).
    $WXSIMtext[$i] = preg_replace('!\.\s+([a-z])!es',"'.  ' . strtoupper('\\1')",$text);
	$WXSIMday[$i] = get_lang($WXSIMday[$i]);
	$wdirs = get_lang('NESW');  // default directions
	if(strlen($wdirs) == 4) {
	  $WXSIMwinddir[$i] = strtr($WXSIMwinddir[$i],'NESW',$wdirs); // do translation
	} elseif (preg_match('|,|',$wdirs)) { //multichar translation
	  $wdirsmc = explode(',',$wdirs);
	  $wdirs = array('N','E','S','W');
	  $wdirlook = array();
	  foreach ($wdirs as $n => $d) {
	    $wdirlook[$d] = $wdirsmc[$n];
	  } 
	  $tstr = ''; // get ready to pass once through the string
	  for ($n=0;$n<strlen($WXSIMwinddir[$i]);$n++) {
	    $c = substr($WXSIMwinddir[$i],$n,1);
	    if(isset($wdirlook[$c])) {
		  $tstr .= $wdirlook[$c]; // use translation
		} else {
		  $tstr .= $c; // use regular
	    }
	  }
      $WXSIMwinddir[$i] = $tstr; // do translation
	
	}
	// translate speed and wind units based on lang entries in one pass
	$text = ' ' . $WXSIMwind[$i] . " \t " . $WXSIMwindunits[$i] . ' '; // make test string.
    reset ($Language); // process in order of the file
    foreach ($Language as $key => $replacement) {
      $text = str_replace($key,$replacement,$text);
    }
    $key = explode("\t",$text);
	$WXSIMwind[$i] = trim($key[0]);
	$WXSIMwindunits[$i] = trim($key[1]);	

  }

 // override icon with hot.jpg if high heat-index or humidex 
 if($WXSIMheatidx[$i] >= $showHotIconF or $WXSIMhumidex[$i] >= $showHotIconC) {
	 $WXSIMicon[$i] = 'hot.jpg';
	 $WXSIMcond[$i] .= "<br/>\n<span style=\"color:red;\"><strong>" . get_lang('Hot!') . "</strong></span>";
 }
  
 // make HTML for full icon with condition description
 $WXSIMicons[$i] = "$WXSIMtitles[$i]<br />
 <img src=\"$iconDir$WXSIMicon[$i]\" alt=\"".strip_tags($WXSIMcond[$i])."\"  title=\"".
 strip_tags($WXSIMcond[$i]) ."\" /><br />
 $WXSIMcond[$i]";
 
} // end of main loop -------------------------


  $IncludeMode = false;
  $PrintMode = true;

  if (isset($doPrint) && ! $doPrint ) {
   //   print $Status;
      return;
  }
  if (isset($_REQUEST['inc']) && 
      strtolower($_REQUEST['inc']) == 'noprint' ) {
	  print $Status;
	  return;
  }

if (isset($_REQUEST['inc']) && strtolower($_REQUEST['inc']) == 'y') {
  $IncludeMode = true;
}
if (isset($doInclude)) {
  $IncludeMode = $doInclude;
}
// V1.03 -- set width of <td> for icons based on overall width/num icons
preg_match('|(\d+)(.*)|',$maxWidth,$widthparts);
//$Status .= "<!-- widthparts\n" . print_r($widthparts,true) . " -->\n";
//$nTD = count($WXSIMicon);
$nTD = $maxIcons;
if ($nTD < 1) { $nTD = 1; }
$wTD = round($widthparts[1]/$nTD,0) . $widthparts[2];
$nUseIcons = min(count($WXSIMicons),$maxIcons);
$Status .= "<!-- maxWidth='$maxWidth' nTD=$nTD wTD='$wTD' Icons to display=$nUseIcons -->\n";

//begin printing of advforecast style printout

print $Status;

if ($printHeading or $printIcons) {
?>
  <div class="WXSIMforecastheader">
  <table width="<?php echo $maxWidth; ?>" style="border: none;">
<?php 
}
if ($printHeading) {
?>
    <tr align="center">
      <td><b><?php echo get_lang("WXSIM Forecast for:");?> </b><span style="color: green;">
	   <?php echo $WXSIMcity; ?></span><br />
        <?php echo get_lang("Issued by:"); ?> <?php echo $WXSIMstation; ?>
      </td>
    </tr>
    <tr>
      <td align="center"><?php echo get_lang("Updated:");?> <?php echo $WXSIMupdated; ?>
	  </td>
    </tr>
<?php
} // end printHeading

if ($printIcons) {
?>
    <tr>
      <td align="center">&nbsp;
	    <table width="<?php echo $maxWidth; ?>" border="0" cellpadding="0" cellspacing="0">  
	      <tr valign ="top" align="center">
	<?php
	  for ($i=0;$i<min(count($WXSIMicons),$maxIcons);$i++) {
	    print "<td style=\"width: $wTD;\"><span>$WXSIMicons[$i]</span></td>\n";
	  }
	?>
          </tr>	
          <tr valign ="top" align="center">
	  <?php
	  for ($i=0;$i<min(count($WXSIMprecip),$maxIcons);$i++) {
	    print "<td style=\"width: $wTD; color: green;\">$WXSIMprecip[$i]</td>\n";
		}
	  ?>
          </tr>
          <tr valign ="top" align="center">
	  <?php
	  for ($i=0;$i<min(count($WXSIMtemp),$maxIcons);$i++) {
	    print "<td style=\"width: $wTD;\">$WXSIMtemp[$i]</td>\n";
	  }
	  ?>
          </tr>
          
      <?php if ($showHumidex or $showFrost or $showHeatIDX) { 
          print "<tr valign =\"top\" align=\"center\">";
	  
	  for ($i=0;$i<min(count($WXSIMhumidex),$maxIcons);$i++) {
		$temp = '';
		if ($WXSIMhumidex[$i] <> '') {$temp = get_lang('Hmdx').': ';
	      print "<td style=\"width: $wTD; color: red;\">$temp$WXSIMhumidex[$i]</td>\n";
		}
		if ($WXSIMheatidx[$i] <> '') {$temp = get_lang('Heat').': ';
	      print "<td style=\"width: $wTD; color: red;\">$temp$WXSIMheatidx[$i]$tempDegrees</td>\n";
		}
		if ($WXSIMfrost[$i] <> '') {
		  $temp = 'Frost ';
		  print "<td style=\"width: $wTD; color: blue;\">$WXSIMfrost[$i]</td>\n";
		}
		if($temp == '') {
		  print "<td style=\"width: $wTD;\">&nbsp;</td>\n";
		  
		}
	  }
	  ?>
          </tr>
      <?php } // end of showHumidex or showFrost ?>
          <tr valign ="top" align="center">
	  <?php
	  for ($i=0;$i<min(count($WXSIMwinddir),$maxIcons);$i++) {
	    print "<td style=\"width: $wTD;\">" . $WXSIMwinddir[$i] . "<br/> " .
		$WXSIMwind[$i] . "<br/> " . $WXSIMwindunits[$i]; 
		if ($showBeaufort) {
		  print "<br/><i>" . $WXSIMBeaufort[$i] ."</i>";
		}
		print "</td>\n";
	  }
	  ?>
          </tr>
          <tr valign ="top" align="center">
	  <?php
	  for ($i=0;$i<min(count($WXSIMuv),$maxIcons);$i++) {
	    print "<td style=\"width: $wTD;\">" . set_UV_string($WXSIMuv[$i]) . "</td>\n";
	  }
	  ?>
          </tr>
        </table>
     </td>
   </tr>
<?php 
}  // end printIcons

if ($printHeading or $printIcons) {
?>
</table>
</div>
  <p>&nbsp;</p>
<?php
} // end heading and icons

if ($printText) {
?>
<div class="WXSIMforecastcontent">

<table style="border: 0" width="<?php echo $maxWidth; ?>">
	<?php
	  for ($i=0;$i<count($WXSIMday);$i++) {
        print "<tr valign =\"top\" align=\"left\">\n";
	    print "<td style=\"width: 20%;\"><b>$WXSIMday[$i]</b><br />&nbsp;<br /></td>\n";
	    print "<td style=\"width: 80%;\">$WXSIMtext[$i]</td>\n";
		print "</tr>\n";
	  }
	?>
</table>
</div><?php 
} // end printText


if (! $IncludeMode) { 
?>
</body>
</html>
<?php
} // print above only if not include mode
}
// Functions -----------------------------------------------------------------------

//  replace text with language lookup text if available
function get_lang( $text ) {
  global $LanguageLookup, $doTranslate;
  if ($doTranslate && isset($LanguageLookup[$text])) {
    $newtext = $LanguageLookup[$text];
  } else {
    $newtext = $text;
  }
 return($newtext);
}
//  decode UV to word+color for display

function set_UV_string ( $uv ) {
// figure out a text value and color for UV exposure text
//  0 to 2  Low
//  3 to 5 	Moderate
//  6 to 7 	High
//  8 to 10 Very High
//  11+ 	Extreme
   switch (TRUE) {
     case ($uv == 0):
       $uv = '';
     break;
     case (($uv > 0) and ($uv < 3)):
       $uv = "UV: $uv<br/>" . '<span style="border: solid 1px; background-color: #A4CE6a;">&nbsp;' . get_lang("Low") .'&nbsp;</span>';
     break;
     case (($uv >= 3) and ($uv < 6)):
       $uv = "UV: $uv<br/>" . '<span style="border: solid 1px;background-color: #FBEE09;">&nbsp;' . get_lang("Medium") .'&nbsp;</span>';
     break;
     case (($uv >=6 ) and ($uv < 8)):
       $uv = "UV: $uv<br/>" . '<span style="border: solid 1px; background-color: #FD9125;">&nbsp;' . get_lang("High") .'&nbsp;</span>';
     break;
     case (($uv >=8 ) and ($uv < 11)):
       $uv = "UV: $uv<br/>" . '<span style="border: solid 1px; color: #FFFFFF; background-color: #F63F37;">&nbsp;' . get_lang('Very&nbsp;High') . '&nbsp;</span>';
     break;
     case (($uv >= 11) ):
       $uv = "UV: $uv<br/>" . '<span style="border: solid 1px; color: #FFFF00; background-color: #807780;">&nbsp;' . get_lang("Extreme") .'&nbsp;</span>';
     break;
   } // end switch
   return $uv;
} // end get_UVrange


// determine Beaufort number based on wind speed and units
function getBeaufort ( $wind, $units) {

global $showBeaufort,$BeaufortMPH,$BeaufortKPH,$BeaufortKTS,$BeaufortMS,$doDebug,$Status;
   switch ($units) {
     case 'mph': $winds = $BeaufortMPH; break;
	 case 'kph': $winds = $BeaufortKPH; break;
	 case 'km/h': $winds = $BeaufortKPH; break;
	 case 'm/s': $winds = $BeaufortMS;  break;
	 case 'mps': $winds = $BeaufortMS;  break;
	 case 'kts': $winds = $BeaufortKTS; break;
	 default: $winds = $BeaufortMPH;
   } // end switch
   $Bft = 0;
   for ($i=0;$i<12;$i++) {
      if ($wind < $winds[$i]) {
	    $Bft = $i;
		break;
	  }
   }
   if ($i > 11 and ! $Bft) { $Bft = 12; };
   if($doDebug) {
	   $Status .= "<!-- '$wind' '$units' bft=$Bft i=$i -->\n";
   }
   return($Bft);

}// end getBeaufort

// perform Beaufort display if desired by showBeaufort setting
function displayBeaufort ($Bft) {
  global $showBeaufort, $BeaufortText;
  if ($Bft < 0 or $Bft > 12 ) { return(""); }

  if ($showBeaufort == 'T') { return( get_lang($BeaufortText[$Bft]) ); }

  if ($showBeaufort == 'V') { return("$Bft Bft"); }

  return("");

}// end displayBeaufort







	
	


if (class_exists("WXSIMForecast")) {
    $WXSIM_pluginSeries = new WXSIMForecast();
}

//Actions and Filters   
if (isset($WXSIM_pluginSeries)) {
    //Actions
    add_action('activate_WXSIMForecast/WXSIMForecast.php',  array(&$WXSIM_pluginSeries, 'init'));
	add_action('admin_menu', 'WXSIMForecast_ap');
    //Filters
	add_shortcode('forecast', 'WXSIMforecast_func');
	//Shortcut
}




?>